unit UnitKauMonoGoukei05;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,printers, Spin, Grids;

type
  TFormKauMonoGoukei05 = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    PanelButtons: TPanel;
    ButtonPrinterSetup: TButton;
    ButtonPrintOut: TButton;
    ButtonNew: TButton;
    ButtonStart: TButton;
    LabelMondai: TLabel;
    LabelHyoudai: TLabel;
    LabelGappiNamae: TLabel;
    LabelHurigana: TLabel;
    PrintDialog1: TPrintDialog;
    LabelProjectName: TLabel;
    PanelMondai1: TPanel;
    GroupBoxHarauOkane1: TGroupBox;
    LabelHarauOkane1: TLabel;
    GroupBoxKaumono1: TGroupBox;
    SaveDialogCSVSaveAs: TSaveDialog;
    GroupBoxStart: TGroupBox;
    GroupBoxStartKauMono: TGroupBox;
    ComboBoxKauMonoShurui: TComboBox;
    LabelStartKauMonoShurui: TLabel;
    SpinEditKazuMin: TSpinEdit;
    SpinEditKazuMax: TSpinEdit;
    LabelStartKauMonoKazu: TLabel;
    ButtonGroupBoxStartClose: TButton;
    PanelMondai2: TPanel;
    GroupBoxHarauOkane2: TGroupBox;
    LabelHarauOkane2: TLabel;
    GroupBoxKaumono2: TGroupBox;
    PanelMondai3: TPanel;
    GroupBoxHarauOkane3: TGroupBox;
    LabelHarauOkane3: TLabel;
    GroupBoxKaumono3: TGroupBox;
    PanelMondai4: TPanel;
    GroupBoxHarauOkane4: TGroupBox;
    LabelHarauOkane4: TLabel;
    GroupBoxKaumono4: TGroupBox;
    StringGridKauMono: TStringGrid;
    PanelTest: TPanel;
    ButtonCSVFileSelect: TButton;
    ButtonCSVFileSaveAs: TButton;
    ButtonComponentCreate: TButton;
    ButtonComponentDelete: TButton;
    ButtonRandomSelect: TButton;
    ButtonKauMonoShuruiYomikomi: TButton;

    procedure FormCreate(Sender: TObject);
    procedure ButtonPrintOutClick(Sender: TObject);
    procedure ButtonPrinterSetupClick(Sender: TObject);
    procedure Renew(Sender: TObject);
    procedure ButtonRadioGroupBoxStartCloseClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox50Click(Sender: TObject);
    procedure CheckBox100Click(Sender: TObject);
    procedure CSVFileSelect(Sender: TObject);
    procedure CSVFileSave(Sender: TObject);
    procedure ComboBoxKauMonoShuruiChange(Sender: TObject);
    procedure SpinEditKazuMinChange(Sender: TObject);
    procedure SpinEditKazuMaxChange(Sender: TObject);
    procedure ButtonGroupBoxStartCloseClick(Sender: TObject);
    procedure ComponentCreate(Sender: TObject);
    procedure ComponentDelete(Sender: TObject);
    procedure KauMonoShuruiYomikomi(Sender: TObject);
  private
    { Private 錾 }
    procedure RansuuHassei;
  public
    { Public 錾 }
  end;

var
  FormKauMonoGoukei05: TFormKauMonoGoukei05;

var
  Margin_Y:integer;            //}[WYW
  Margin_X:integer;            //}[WXW
  count:integer;//ImageR|[lg̐
implementation

{$R *.DFM}

procedure TFormKauMonoGoukei05.RansuuHassei;
begin
end;

procedure TFormKauMonoGoukei05.FormCreate(Sender: TObject);
begin
  LabelProjectName.Caption:='KaumonoGoukei04';
  Margin_x:=10;
  Margin_y:=5;
  KauMonoShuruiYomikomi( Sender);
  ComboBoxKauMonoShurui.Text:='낢';
  ButtonStart.Hide;
  PanelTest.hide;
  StringGridKauMono.Hide;
  Color:= clWhite;
  BorderStyle:= bsSizeable;
  PrintScale:= poPrintToFit;
  Scaled:= True;

  CSVFileSelect(Sender);
  Renew(Sender);
end;

procedure TFormKauMonoGoukei05.ButtonPrinterSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFormKauMonoGoukei05.ButtonPrintOutClick(Sender: TObject);
begin
  PanelButtons.hide;
  GroupBoxStart.Hide;

  printer.Orientation:= poLandscape;//v^ZbgAbv_CAOʂAڂɉuɐݒ

  Printer.Title:=self.Text;
  Self.Print;

  GroupBoxStart.Show;
  PanelButtons.Show;

  Renew(Sender);
end;

procedure TFormKauMonoGoukei05.Renew(Sender: TObject);
begin
  LabelHyoudai.Caption:='̎:'+ComboBoxKauMonoShurui.Text+ ', '+ ':'+inttostr(SpinEditKazuMin.value)+'`'+inttostr(SpinEditKazuMax.value);
  ComponentDelete(Sender);
  ComponentCreate(Sender);
end;

procedure TFormKauMonoGoukei05.ButtonRadioGroupBoxStartCloseClick(Sender: TObject);
begin
  ButtonStart.Show;
end;

procedure TFormKauMonoGoukei05.ButtonStartClick(Sender: TObject);
begin
  ButtonStart.Hide;
  GroupBoxStart.Show;
end;

procedure TFormKauMonoGoukei05.CheckBox1Click(Sender: TObject);
begin
    ransuuhassei;
    ButtonNew.click;
end;

procedure TFormKauMonoGoukei05.CheckBox5Click(Sender: TObject);
begin
    ransuuhassei;
    ButtonNew.Click;
end;

procedure TFormKauMonoGoukei05.CheckBox10Click(Sender: TObject);
begin
    ransuuhassei;
    ButtonNew.Click;
end;

procedure TFormKauMonoGoukei05.CheckBox50Click(Sender: TObject);
begin
    ransuuhassei;
    ButtonNew.Click;
end;

procedure TFormKauMonoGoukei05.CheckBox100Click(Sender: TObject);
begin
    ransuuhassei;
    ButtonNew.Click;
end;

procedure TFormKauMonoGoukei05.CSVFileSelect(Sender: TObject);
var
  InputFile: TextFile;
  TmpStringList: TStringList;
  TxtLineData: String;
  i: Integer;
begin
  i := 0;
  //2s͌ŒJiDF̕j̐
  StringGridKauMono.FixedCols := 0;
  StringGridKauMono.FixedRows := 0;
  StringGridKauMono.RowCount := 1;    //ĥ߂ɍŏɂĂ
  StringGridKauMono.ColCount := 2;    //́Ali

  //̗̐킹邽߂1Iȃf[^i[ꏊ
  TmpStringList := TStringList.Create;

  AssignFile(InputFile, '\'+ComboBoxKauMonoShurui.text+'.csv');
  Reset(InputFile);
  try
    while not SeekEof(InputFile) do //t@C̏I܂ő
    begin
      ReadLn(InputFile, TxtLineData);//1sǂݍ

      //1sCSV`̃f[^11̃f[^ɕBiCommaTextvpeB1sCSVf[^ƁAIɕĔẑ悤Ɉj
      TmpStringList.CommaText := TxtLineData;

      //if͓ǂݎt@C̃f[^̐i̗̐j̍őlObhColɍ킹
      if TmpStringList.Count > StringGridKauMono.ColCount then StringGridKauMono.ColCount := TmpStringList.Count;

      //Obh̍s̐ǂݍ񂾃t@C̍s̐ɍ킹đ₷
      StringGridKauMono.RowCount := i + 1;

      //̃Rs[
      StringGridKauMono.Rows[i].Assign(TmpStringList);

      inc(i);
    end;
  finally
    TmpStringList.Free;
    CloseFile(InputFile);
  end;
end;

procedure TFormKauMonoGoukei05.CSVFileSave(Sender: TObject);
var
   i:integer;
   f:TextFile;
begin
   if not savedialogCSVSaveAs.Execute then exit;
   assignFile(f,savedialogCSVSaveAs.FileName);
   rewrite(f);
   try
      for i:=0 to StringGridKauMono.rowCount-1 do
         writeln(f,StringGridKauMono.Rows[i].commatext);
   finally
      closeFile(f);
   end;
end;

procedure TFormKauMonoGoukei05.ComboBoxKauMonoShuruiChange(Sender: TObject);
begin
  CSVFileSelect(Sender);
  Renew(sender);
end;

procedure TFormKauMonoGoukei05.SpinEditKazuMinChange(Sender: TObject);
begin
  if SpinEditKazuMin.Value> SpinEditKazuMax.Value then SpinEditKazuMin.Value:= SpinEditKazuMax.Value;
  Renew(sender);
end;

procedure TFormKauMonoGoukei05.SpinEditKazuMaxChange(Sender: TObject);
begin
  if SpinEditKazuMax.Value< SpinEditKazuMin.Value then SpinEditKazuMax.Value:= SpinEditKazuMin.Value;
  Renew(sender);
end;

procedure TFormKauMonoGoukei05.ButtonGroupBoxStartCloseClick(Sender: TObject);
begin
  GroupBoxStart.Hide;
  ButtonStart.Show;
end;

procedure TFormKauMonoGoukei05.ComponentCreate(Sender: TObject);
var
  DynImage:  TImage;
  DynImageName: string;
  DynLabel:  TLabel;
  DynLabelName: string;
  k,p,i,_row: integer;
  pictureWidth,pictureHeight,pictureLeft,pictureTop:integer;
  LabelWidth,LabelHeight,LabelLeft,LabelTop:integer;
  kazu:array [1..4] of integer;
begin
  randomize;
  for k:= 1 to 4 do kazu[k]:=random(SpinEditKazuMax.value- SpinEditKazuMin.Value+1)+SpinEditKazuMin.Value;
  for p:=1 to 4 do
  begin
    count:=0;
    pictureLeft:=Margin_X;
    for i:= 1 to kazu[p] do
    begin
      inc(count);
      _row:= random(StringgridKauMono.RowCount);

      DynImageName:= 'DynImage'+inttostr(p)+ '_'+ IntToStr(count);
      if FindComponent(DynImageName) <> nil then Exit;  { łɃR|[lg𐶐Ăꍇ́AȂ }
      DynImage := TImage.Create(Self);
      case p of                                { eR|[lgw肷 }
        1:DynImage.Parent := GroupBoxKauMono1;
        2:DynImage.Parent := GroupBoxKauMono2;
        3:DynImage.Parent := GroupBoxKauMono3;
        4:DynImage.Parent := GroupBoxKauMono4;
      end;
      DynImage.Picture.LoadFromFile('\'+ComboBoxKauMonoShurui.text+'\'+StringgridKauMono.Cells[0,_row]+'.bmp');       {C[Ww肷 }
      pictureTop:= GroupBoxKaumono1.height- Margin_Y- 24- Margin_Y- DynImage.Picture.Height;
      pictureWidth:= DynImage.Picture.width;
      pictureHeight:= DynImage.Picture.Height;
      DynImage.SetBounds( pictureLeft, pictureTop, pictureWidth, pictureHeight);  { ʒuƑ傫w肷 Left, Top, width, Height }
      pictureLeft:= PictureLeft+ PictureWidth+ Margin_X;
      DynImage.Name := DynImageName;                   { R|[lgw肷 }

      DynLabelName:= 'DynLabel'+inttostr(p)+ '_'+ IntToStr(count);
      if FindComponent(DynLabelName) <> nil then Exit;  { łɃR|[lg𐶐Ăꍇ́AȂ }
      DynLabel := TLabel.Create(Self);
      case p of                                { eR|[lgw肷 }
        1:DynLabel.Parent := GroupBoxKauMono1;
        2:DynLabel.Parent := GroupBoxKauMono2;
        3:DynLabel.Parent := GroupBoxKauMono3;
        4:DynLabel.Parent := GroupBoxKauMono4;
      end;
//      DynLabel.Transparent:=true;                       {  }
      DynLabel.Font.Size:=18;
      DynLabel.Caption:=StringgridKauMono.Cells[1,_row]+'~';       {LvVw肷 }
      LabelWidth:= DynLabel.width;
      LabelTop:= GroupBoxKaumono1.height- Margin_Y- 24- Margin_Y;
      LabelLeft:= round(pictureLeft- pictureWidth/2-LabelWidth/2)- Margin_X;
      LabelHeight:= DynLabel.Height;
      DynLabel.SetBounds( LabelLeft, LabelTop, LabelWidth, LabelHeight);  { ʒuƑ傫w肷 Left, Top, width, Height }
      DynLabel.Name := DynLabelName;                   { R|[lgw肷 }
    end;
  end;
end;

procedure TFormKauMonoGoukei05.ComponentDelete(Sender: TObject);
var
  DynImage,DynLabel: TComponent;
  DynImageName,DynLabelName: string;
  p,i: integer;
begin
  for p:=1 to 4 do
  begin
    for i:= 1 to 5 do
    begin
      DynImageName:= 'DynImage'+inttostr(p)+ '_'+ IntToStr(i);
      DynImage := FindComponent(DynImageName);  { IɐR|[lgT }
      if DynImage <> nil then DynImage.Free;     { R|[lgꍇinil łȂꍇjA R|[lg }

      DynLabelName:= 'DynLabel'+inttostr(p)+ '_'+ IntToStr(i);
      DynLabel := FindComponent(DynLabelName);  { IɐR|[lgT }
      if DynLabel <> nil then DynLabel.Free;     { R|[lgꍇinil łȂꍇjA R|[lg }
    end;
  end;
end;

procedure TFormKauMonoGoukei05.KauMonoShuruiYomikomi( Sender: TObject);
begin
  try
    ComboBoxKauMonoShurui.Items.LoadFromFile('\̎.txt');
  except
    showmessage('''̎.txt''A܂͉Ă܂B');
  end;
end;

end.
